import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;

public class Ascii2Hex extends Form implements CommandListener {
 private midlet midlet;
 private Display dpy;
 private Displayable prev;
 private Command 
  cmdAscii2Hex = new Command("Ascii->Hex", Command.ITEM, 1),
  cmdHex2Ascii = new Command("Hex->Ascii", Command.ITEM, 1),
  cmdConvert = new Command(" ..", Command.ITEM, 2);
 private TextField From,To;
 private static String 
  Win1251=" !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~",
  Hex="0123456789aAbBcCdDeEfF";

 public Ascii2Hex (midlet midlet,Display dpy) {
  super ("ASCII<->HEX");
  this.midlet=midlet;
  this.dpy = dpy;
  prev = dpy.getCurrent();
  From = new TextField (":","",64,TextField.ANY);
  To = new TextField (":","",256,TextField.ANY);
  append (From);
  append (To);
  addCommand (cmdAscii2Hex);
  addCommand (cmdHex2Ascii);
  addCommand (cmdConvert);
  addCommand (midlet.cmdAbout);
  addCommand (midlet.cmdExit);
  setCommandListener(this);
  dpy.setCurrent (this);  
 }

 private void alert (String msg) {
  dpy.setCurrent (new Alert ("",msg,null,AlertType.ERROR),dpy.getCurrent());
 }
 

 public void commandAction (Command cmd, Displayable d) {
  String r="",r0,c,s=From.getString().trim();
  int n,i,l=s.length();
  if (cmd==cmdAscii2Hex) {
   for (i=0; i<l; i++) {
    c=s.substring(i,i+1);
    n=Win1251.indexOf(c);
    if (n==-1) r+="??";
    else {
     n+=32;
     try {
      r0=Integer.toString (n,16);
     }
     catch (NumberFormatException ne) { 
      alert (" '"+c+"' ");
      return;
     }
     r+=r0+" ";
    }
   }
   To.setString(r.trim());
  }
  else if (cmd==cmdHex2Ascii) {
   char ch;
   if (l%2!=0) s+="0";
   for (i=0; i<l; i+=2) {
    c=s.substring(i,i+2);
    try {
     n=Integer.parseInt (c,16);
    }
    catch (NumberFormatException ne) {
     alert (" '"+c+"'  16-");
     return;
    }
    if (n<32) r0="\\"+n+" ";
    else {
     n-=32;
     r0=""+Win1251.charAt(n);
    }
    r+=r0;
   }
   To.setString(r);
  }
  else if (cmd==midlet.cmdAbout) {
   errorForm er = new errorForm (dpy,midlet.cmdAbout.getLabel());
   er.show (
    "  ASCII   Windows-1251  16-  (HEX)  .\n"+
    "   0..31 - ,     ,       \\N[],  N -   .\n"+
    "(C) PerS, pers@mail.ru"
   );
  }
  else if (cmd==cmdConvert) {
   dpy.setCurrent(prev);
  }
  else {
   midlet.exit();
  }
 }

}

